DCMTK Version 3.7.0 OFFIS DICOM Toolkit

Public Member Functions | Static Private Attributes | List of all members
IODImagePixelBase Class Referenceabstract

Base class for deriving Image Pixel Module, Floating Point Image Pixel Module and Double Floating Point Image Pixel (and maybe more later) More...

Inheritance diagram for IODImagePixelBase:

## Public Member Functions
| IODImagePixelBase (OFshared_ptr< DcmItem > item, OFshared_ptr< IODRules > rules)
| Constructor. More...
| IODImagePixelBase ()
| Constructor.
virtual | ~IODImagePixelBase ()
| Destructor.
virtual void | resetRules ()
| Resets rules to their original values.
virtual OFString | getName () const
| Get name of module. More...
virtual DataType | getDataType () const =0
| Get pixel data type. More...
virtual OFCondition | getSamplesPerPixel (Uint16 &value, const unsigned long pos=0)
| Get Samples per Pixel. More...
virtual OFCondition | getPhotometricInterpretation (OFString &value, const signed long pos=0)
| Get Photometric Interpretation. More...
virtual OFCondition | getRows (Uint16 &value, const unsigned long pos=0)
| Get Rows. More...
virtual OFCondition | getColumns (Uint16 &value, const unsigned long pos=0)
| Get Columns. More...
virtual OFCondition | getBitsAllocated (Uint16 &value, const unsigned long pos=0)
| Get Bits Allocated. More...
virtual OFCondition | getPixelAspectRatio (Uint16 &value, const unsigned long pos=0)
| Get Pixel Aspect Ratio. More...
virtual OFCondition | setRows (const Uint16 value, const OFBool checkValue=OFTrue)
| Set Rows. More...
virtual OFCondition | setColumns (const Uint16 value, const OFBool checkValue=OFTrue)
| Set Columns. More...
virtual OFCondition | setPixelAspectRatio (const OFString &verticalPixelSize, const OFString &horizontalPixelSize, const OFBool checkValue=OFTrue)
| Set Pixel Aspect Ratio. More...
Public Member Functions inherited from IODModule
| IODModule (OFshared_ptr< DcmItem > item, OFshared_ptr< IODRules > rules)
| Constructor. More...
| IODModule ()
| Constructor. More...
| IODModule (const IODModule &rhs)
| Copy constructor, creates shallow copy. More...
IODModule & | operator= (const IODModule &rhs)
| Assignment operator, creates shallow copy. More...
| ~IODModule ()
| Destructor.
Public Member Functions inherited from IODComponent
| IODComponent (OFshared_ptr< DcmItem > item, OFshared_ptr< IODRules > rules, IODComponent *parent=NULL)
| Constructor. More...
| IODComponent (IODComponent *parent=NULL)
| Constructor, creates rules and item from scratch. More...
IODComponent & | operator= (const IODComponent &rhs)
| Assignment operator, copies contained item and rule set from rhs to "this" attribute set. More...
| IODComponent (const IODComponent &rhs)
| Copy constructor, copies reference to contained item and rule set to "this" attribute set. More...
virtual | ~IODComponent ()
| Virtual Destructor.
virtual void | clearData ()
| Clear all attributes from the data that are handled by this module. More...
virtual void | inventMissing ()
| Set missing values by inventing "default values". More...
OFshared_ptr< IODRules > | getRules ()
| Get rules handled by this module. More...
virtual void | makeOptional ()
| Make component optional by turning all attributes requirement types of it to type 3. More...
DcmItem & | getData ()
| Get the data handled by this module. More...
virtual OFCondition | read (DcmItem &source, const OFBool clearOldData=OFTrue)
| Read attributes from given item into this class. More...
virtual OFCondition | write (DcmItem &destination)
| Write attributes from this class into given item. More...
virtual OFCondition | check (const OFBool quiet=OFFalse)
| Check whether this component's data satisfies the underlying rules. More...
virtual int | compare (const IODComponent &rhs) const
| Comparison operator for IOD Components. More...
virtual bool | getValueCheckOnWrite () const
| Get whether attribute value errors will be handled as errors on writing. More...
virtual void | setValueCheckOnWrite (const OFBool checkValue)
| Set whether attribute values should be checked on writing, i.e. More...

## Static Private Attributes
static const OFString | m_ModuleName
| This module's name ("ImagePixelBase")

## Additional Inherited Members
Static Public Member Functions inherited from IODComponent
static OFCondition | read (DcmItem &source, IODRules &rules, DcmItem &destination, const OFString &componentName)
| Static helper function that reads attributes from given item into destination item, as determined by the provided rules and component name. More...
static OFCondition | write (DcmItem &source, IODRules &rules, DcmItem &destination, const OFString &componentName, const OFBool checkValue)
| Static helper function that writes attributes from given item into destination item, as determined by the provided rules and component name. More...
Protected Attributes inherited from IODComponent
OFshared_ptr< DcmItem > | m_Item
| Shared pointer to the data handled by this class. More...
OFshared_ptr< IODRules > | m_Rules
| Rules describing the attributes governed by this class.
IODComponent * | m_Parent
| The parent component (may be NULL) of this class.
OFBool | m_CheckValueOnWrite
| Denotes whether attribute values should be checked on writing, i.e. More...

## Detailed Description

Base class for deriving Image Pixel Module, Floating Point Image Pixel Module and Double Floating Point Image Pixel (and maybe more later)

## Constructor & Destructor Documentation

## ◆ IODImagePixelBase()

IODImagePixelBase::IODImagePixelBase | ( | OFshared_ptr< DcmItem > | item,
|  | OFshared_ptr< IODRules > | rules
| ) |  |

Constructor.

Parameters

  item | The item to be used for data storage. If NULL, the class creates an empty data container.
  rules | The rule set for this class. If NULL, the class creates one from scratch and adds its values.

## Member Function Documentation

## ◆ getBitsAllocated()

virtual OFCondition IODImagePixelBase::getBitsAllocated | ( | Uint16 & | value,
|  | const unsigned long | pos = `0`
| ) |  |
| virtual

Get Bits Allocated.

Parameters

  value | Reference to variable in which the value should be stored
  pos | Index of the value to get (0..vm-1)

Returns
  EC_Normal if successful, an error code otherwise

## ◆ getColumns()

virtual OFCondition IODImagePixelBase::getColumns | ( | Uint16 & | value,
|  | const unsigned long | pos = `0`
| ) |  |
| virtual

Get Columns.

Parameters

  value | Reference to variable in which the value should be stored
  pos | Index of the value to get (0..vm-1)

Returns
  EC_Normal if successful, an error code otherwise

## ◆ getDataType()

virtual DataType IODImagePixelBase::getDataType | ( |  | ) | const
| pure virtual

Get pixel data type.

Returns
  The data type of the pixel data

Implemented in IODImagePixelModule< T >, IODDoubleFloatingPointImagePixelModule, and IODFloatingPointImagePixelModule.

## ◆ getName()

virtual OFString IODImagePixelBase::getName | ( |  | ) | const
| virtual

Get name of module.

Returns
  Name of the module ("ImagePixelModule")

Implements IODComponent.

Reimplemented in IODImagePixelModule< T >, IODDoubleFloatingPointImagePixelModule, and IODFloatingPointImagePixelModule.

## ◆ getPhotometricInterpretation()

virtual OFCondition IODImagePixelBase::getPhotometricInterpretation | ( | OFString & | value,
|  | const signed long | pos = `0`
| ) |  |
| virtual

Get Photometric Interpretation.

Parameters

  value | Reference to variable in which the value should be stored
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal if successful, an error code otherwise

## ◆ getPixelAspectRatio()

virtual OFCondition IODImagePixelBase::getPixelAspectRatio | ( | Uint16 & | value,
|  | const unsigned long | pos = `0`
| ) |  |
| virtual

Get Pixel Aspect Ratio.

Parameters

  value | Reference to variable in which the value should be stored
  pos | Index of the value to get (0..vm-1)

Returns
  EC_Normal if successful, an error code otherwise

## ◆ getRows()

virtual OFCondition IODImagePixelBase::getRows | ( | Uint16 & | value,
|  | const unsigned long | pos = `0`
| ) |  |
| virtual

Get Rows.

Parameters

  value | Reference to variable in which the value should be stored
  pos | Index of the value to get (0..vm-1)

Returns
  EC_Normal if successful, an error code otherwise

## ◆ getSamplesPerPixel()

virtual OFCondition IODImagePixelBase::getSamplesPerPixel | ( | Uint16 & | value,
|  | const unsigned long | pos = `0`
| ) |  |
| virtual

Get Samples per Pixel.

Parameters

  value | Reference to variable in which the value should be stored
  pos | Index of the value to get (0..vm-1)

Returns
  EC_Normal if successful, an error code otherwise

## ◆ setColumns()

virtual OFCondition IODImagePixelBase::setColumns | ( | const Uint16 | value,
|  | const OFBool | checkValue = `OFTrue`
| ) |  |
| virtual

Set Columns.

Parameters

  value | Reference to variable in which the value should be stored
  checkValue | Check 'value'. Not evaluated (here for consistency with other setter functions).

Returns
  EC_Normal if successful, an error code otherwise

## ◆ setPixelAspectRatio()

virtual OFCondition IODImagePixelBase::setPixelAspectRatio | ( | const OFString & | verticalPixelSize,
|  | const OFString & | horizontalPixelSize,
|  | const OFBool | checkValue = `OFTrue`
| ) |  |
| virtual

Set Pixel Aspect Ratio.

Parameters

  verticalPixelSize | The vertical pixel size (no unit)
  horizontalPixelSize | The horizontal pixel size (no unit)
  checkValue | Check 'value' for conformance with VR (IS)

Returns
  EC_Normal if successful, an error code otherwise

## ◆ setRows()

virtual OFCondition IODImagePixelBase::setRows | ( | const Uint16 | value,
|  | const OFBool | checkValue = `OFTrue`
| ) |  |
| virtual

Set Rows.

Parameters

  value | Reference to variable in which the value should be stored
  checkValue | Check 'value'. Not evaluated (here for consistency with other setter functions).

Returns
  EC_Normal if successful, an error code otherwise

The documentation for this class was generated from the following file:

- dcmiod/include/dcmtk/dcmiod/modimagepixelbase.h

Generated on Mon Dec 15 2025 for DCMTK Version 3.7.0 by Doxygen 1.9.1